#include"d3d.h"
void D3D::Error(LPSTR m)
{
	MessageBox(m_hWnd,m,"G[",MB_OK);
}
//-----------------------------------------------------------------------------
// Name: InitD3D()
// Desc: Initializes Direct3D
//-----------------------------------------------------------------------------
HRESULT D3D::InitD3D( HWND hWnd )
{
	m_hWnd=hWnd;
    // Create the D3D object.
    if( NULL == ( g_pD3D = Direct3DCreate8( D3D_SDK_VERSION ) ) ){
		Error("Direct3Dł܂B");
        return E_FAIL;
	}
    // Get the current desktop display mode, so we can set up a back
    // buffer of the same format
    D3DDISPLAYMODE d3ddm;
//    if( FAILED( g_pD3D->GetAdapterDisplayMode( D3DADAPTER_DEFAULT, &d3ddm ) ) ){
//		Error("fBXvC[hݒł܂B");
//        return E_FAIL;
//	}
    D3DPRESENT_PARAMETERS d3dpp; 
    ZeroMemory( &d3dpp, sizeof(d3dpp) );
	int adapter=0;
	// ݂̉ʃ[h擾
	if( FAILED(g_pD3D->GetAdapterDisplayMode(adapter,&d3ddm))){
		Error("fBXvC[hݒł܂B");
        return E_FAIL;
	}
    // Set up the structure used to create the D3DDevice. Since we are now
    // using more complex geometry, we will create a device with a zbuffer.
//    d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
//    d3dpp.EnableAutoDepthStencil = TRUE;
//    d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
	if (FULLSCREEN)
	{
		// tXN[ : قƂǂ̃A_v^ŃT|[gĂtH[}bggp
		d3dpp.BackBufferFormat = D3DFMT_R5G6B5;
	}
	else
	{
		// EChE : ݂̉ʃ[hgp
		d3dpp.BackBufferFormat = d3ddm.Format;
	    d3dpp.Windowed = TRUE;
	}
	// \̈TCY̐ݒ
//	d3dpp.BackBufferWidth = 640;
//	d3dpp.BackBufferHeight = 480;
	d3dpp.SwapEffect = D3DSWAPEFFECT_FLIP;
	if (!FULLSCREEN)
	{
		// EChE[h
		d3dpp.Windowed = 1;
	}
	// Z obt@̎쐬
	d3dpp.EnableAutoDepthStencil = 1;
	d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
	
    // Create the D3DDevice
//    if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
//                                      D3DCREATE_SOFTWARE_VERTEXPROCESSING,
//                                      &d3dpp, &g_pd3dDevice ) ) )
//    {
//		Error("foCXł܂B");
//        return E_FAIL;
//    }
	// foCX̍쐬 - T&L HAL
	if (FAILED(g_pD3D->CreateDevice(adapter,D3DDEVTYPE_HAL,hWnd,D3DCREATE_HARDWARE_VERTEXPROCESSING,&d3dpp,&g_pd3dDevice)))
	{
		// ŝ HAL Ŏs
		if (FAILED(g_pD3D->CreateDevice(adapter,D3DDEVTYPE_HAL,hWnd,D3DCREATE_SOFTWARE_VERTEXPROCESSING,&d3dpp,&g_pd3dDevice)))
		{
			// ŝ REF Ŏs
			if (FAILED(g_pD3D->CreateDevice(adapter,D3DDEVTYPE_REF,hWnd,D3DCREATE_SOFTWARE_VERTEXPROCESSING,&d3dpp,&g_pd3dDevice)))
			{
				// ǎs
				MessageBox(NULL,"Direct3D ̏Ɏs܂B","ERROR",MB_OK | MB_ICONSTOP);
//				RELEASE(lpD3D);
				// I
				return E_FAIL;
			}
		}
	}

    // Turn on the zbuffer
    g_pd3dDevice->SetRenderState( D3DRS_ZENABLE, TRUE );

    // Turn on ambient lighting 
    g_pd3dDevice->SetRenderState( D3DRS_AMBIENT, 0x20202020 );
	//
 
    return S_OK;
}




//-----------------------------------------------------------------------------
// Name: InitGeometry()
// Desc: Load the mesh and build the material and texture arrays
//-----------------------------------------------------------------------------
HRESULT D3DObject::InitGeometry(char* ModelName)
{
    LPD3DXBUFFER pD3DXMtrlBuffer;

    // Load the mesh from the specified file
	//"HIKARU01.x""Tiger.x" "usagi2.x"  "misya4.x" "misya4m.x" "ero2.x"
    if( FAILED( D3DXLoadMeshFromX(ModelName, D3DXMESH_SYSTEMMEM, 
                                   *g_pd3dDevice, NULL, 
                                   &pD3DXMtrlBuffer, &g_dwNumMaterials, 
                                   &g_pMesh ) ) )
    {
        return E_FAIL;
    }

    // We need to extract the material properties and texture names from the 
    // pD3DXMtrlBuffer
    D3DXMATERIAL* d3dxMaterials = (D3DXMATERIAL*)pD3DXMtrlBuffer->GetBufferPointer();
    g_pMeshMaterials = new D3DMATERIAL8[g_dwNumMaterials];
    g_pMeshTextures  = new LPDIRECT3DTEXTURE8[g_dwNumMaterials];

    for( DWORD i=0; i<g_dwNumMaterials; i++ )
    {
        // Copy the material
        g_pMeshMaterials[i] = d3dxMaterials[i].MatD3D;

        // Set the ambient color for the material (D3DX does not do this)
        g_pMeshMaterials[i].Ambient = g_pMeshMaterials[i].Diffuse;
     
        // Create the texture
        if( FAILED( D3DXCreateTextureFromFile( *g_pd3dDevice, 
                                               d3dxMaterials[i].pTextureFilename, 
                                               &g_pMeshTextures[i] ) ) )
        {
            g_pMeshTextures[i] = NULL;
        }
    }

    // Done with the material buffer
    pD3DXMtrlBuffer->Release();

	//
    return S_OK;
}
void D3D::InitLight()
{
	D3DLIGHT8 d3dLight;
	HRESULT   hr;

	// \̂B
	ZeroMemory(&d3dLight, sizeof(D3DLIGHT8));

	// F̃|Cg Cg̐ݒsB
	d3dLight.Type = D3DLIGHT_POINT;
	d3dLight.Diffuse.r  = 0.50f;
	d3dLight.Diffuse.g  = 0.50f;
	d3dLight.Diffuse.b  = 0.50f;
	d3dLight.Ambient.r  = 0.50f;
	d3dLight.Ambient.g  = 0.50f;
	d3dLight.Ambient.b  = 0.50f;
	d3dLight.Specular.r = 1.0f;
	d3dLight.Specular.g = 1.0f;
	d3dLight.Specular.b = 1.0f;

	// |Cg CgV[̏㕔Ńr[A̔wɔzuB
	// ̍W̓[hԂ̂̂łB
	// [U[̓[hԓ̂ǂ̈ʒuWɂł݂łB 
	// ̃R[hł́A
	// [U[̓[hԂ̌_ɂƉ肵ĂB
	d3dLight.Position.x = 5.0f;
	d3dLight.Position.y = 800.0f;
	d3dLight.Position.z = -10.0f;


	// ȂB
	d3dLight.Attenuation0 = 1.0f; 
	d3dLight.Range      = 10000.0f;

	// ŏ̃Cg̃vpeBݒ肷B
	hr = g_pd3dDevice->SetLight(0, &d3dLight);
	if (FAILED(hr))
	{
		// G[R[hB
		Error("Cgݒł܂B");
	}

	hr = g_pd3dDevice->LightEnable(0, TRUE);
	if (FAILED(hr))
	{
		// G[R[hB
		Error("Cgg܂B");
	}


}



//-----------------------------------------------------------------------------
// Name: Cleanup()
// Desc: Releases all previously initialized objects
//-----------------------------------------------------------------------------
VOID D3D::Cleanup()
{
	for(int i=0;i<MAX_OBJECT;++i)
		Obj[i].DeleteObj();
     
    if( g_pd3dDevice != NULL )
        g_pd3dDevice->Release();

    if( g_pD3D != NULL )
        g_pD3D->Release();
}



//-----------------------------------------------------------------------------
// Name: SetupMatrices()
// Desc: Sets up the world, view, and projection transform matrices.
//-----------------------------------------------------------------------------
VOID D3D::SetupMatrices(float x,float y,float z,float rx,float ry,float rz)
{
 	static float r=0.0f;
	r=r+0.01f;
	if(r>6.28)r=0.0f;

	D3DXMATRIX matWorld,matRotateX,matRotateY,matRotateZ,matTrans;

    D3DXMatrixRotationX( &matRotateX, rx);//timeGetTime()/1000.0f );
    D3DXMatrixRotationY( &matRotateY, ry );
    D3DXMatrixRotationZ( &matRotateZ, rz );
	// ړ
	D3DXMatrixTranslation(&matTrans,x , y, z);
	// s쐬
	matWorld = matRotateX * matRotateY * matRotateZ * matTrans;
	// esݒ
	g_pd3dDevice->SetTransform(D3DTS_WORLD,&matWorld);
	//
    D3DXMATRIX matView;
    D3DXMatrixLookAtLH( &matView, &D3DXVECTOR3( CameraVX, CameraVY, CameraVZ ), 
                                  &D3DXVECTOR3( CameraX, CameraY, CameraZ ), 
                                  &D3DXVECTOR3( 0.0f, 1.0f, 0.0f ) );
    g_pd3dDevice->SetTransform( D3DTS_VIEW, &matView );

    D3DXMATRIX matProj;
    D3DXMatrixPerspectiveFovLH( &matProj, D3DX_PI/4, 1.3333333f, 0.1f, 10000.0f );
    g_pd3dDevice->SetTransform( D3DTS_PROJECTION, &matProj );
}



void D3D::DrawObject(int p)
{
	if(Obj[p].UseFlag){
		SetupMatrices(Obj[p].x ,Obj[p].y ,Obj[p].z ,Obj[p].rx ,Obj[p].ry ,Obj[p].rz);
		//for(int k=0; k<MAX_OBJECT; k++ ){
		int k=p;
			for( DWORD i=0; i<Obj[k].g_dwNumMaterials; i++ )
			{
				// Set the material and texture for this subset
				g_pd3dDevice->SetMaterial( &Obj[k].g_pMeshMaterials[i] );
				g_pd3dDevice->SetTexture( 0, Obj[k].g_pMeshTextures[i] );
        
				// Draw the mesh subset
				Obj[k].g_pMesh->DrawSubset( i );
			}
		//}
	}
}
//-----------------------------------------------------------------------------
// Name: Render()
// Desc: Draws the scene
//-----------------------------------------------------------------------------
VOID D3D::Render()
{
    // Clear the backbuffer and the zbuffer
    g_pd3dDevice->Clear( 0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, 
                         D3DCOLOR_XRGB(0,0,255), 1.0f, 0 );
    
   // Begin the scene
    g_pd3dDevice->BeginScene();
	for(int p=0;p<MAX_OBJECT;++p){
		DrawObject(p);
	}
    // End the scene
    g_pd3dDevice->EndScene();
    
    // Present the backbuffer contents to the display
    g_pd3dDevice->Present( NULL, NULL, NULL, NULL );
	{
			// `揈
			static int time1=0,time2=0,count=0,count2=0;
			time1=GetTickCount();
			if(time1>(time2+1000)){
				count=count2;
				count2=0;
				time2=time1;
			}
			++count2;
			HDC hDC=GetWindowDC(m_hWnd);
			char moji[256];
			wsprintf(moji,"%d [flame] %s",count,DebugString);
			TextOut(hDC,50,0,moji,strlen(moji));
		//	SetWindowText(hWnd,moji);
			ReleaseDC(m_hWnd,hDC);
	}
}


