#include"d3d.h"
#include<stdio.h>


//-----------------------------------------------------------------------------
// Name: MsgProc()
// Desc: The window's message handler
//-----------------------------------------------------------------------------
int ViewMode=0;

LRESULT WINAPI MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
    switch( msg )
    {
        case WM_DESTROY:
            PostQuitMessage( 0 );
            return 0;
		case WM_KEYDOWN:
			{
				int nVirtKey = (int) wParam;	/* zL[ R[h	*/
				switch(nVirtKey){
					case VK_SPACE:
						ViewMode ^=1;
					break;
				}
			}
			break;
		case WM_SIZE:
			SetWindowPos(hWnd,HWND_TOP	,0,0,640,480,SWP_NOMOVE	);
			break;
    }

    return DefWindowProc( hWnd, msg, wParam, lParam );
}
struct Vector
{
	float x,y,z;
	float rx,ry,rz;
	Vector()
	{
		x=y=z=0.0f;
		rx=ry=rz=0.0f;
	}
};
Vector Player;
#define MAX_ENEMY 5
#define MAX_TREE 300
Vector Enemy[MAX_ENEMY];
float EnemyRad[MAX_ENEMY];
int EnemyWait[MAX_ENEMY];
int EnemyMuki[MAX_ENEMY];
D3D d3d;
Vector Camera[300];
int Speed=1;
void Init()
{
	d3d.LoadObject(0,"mig19.x");
	d3d.LoadObject(1,"flag.x");
	int i;
	/*
	for(i=0;i<10;++i)
		d3d.LoadObject(30+i,"mig19.x");
		*/
//	d3d.SetObjectPos(0,0,0,0);
	for(i=0;i<MAX_TREE;++i){
		d3d.LoadObject(50+i,"tree.x");
		float x=(float)(rand()%300 -150);
		float z=(float)(rand()%300 -150);
		d3d.SetObjectPos(50+i,x,-0.5,z);
	}
	Player.x=Player.y=0.0f;
	Player.z=0.0f;
	Player.rx=Player.ry=Player.rz=0.0f;
	for(i=0;i<MAX_ENEMY;++i){
		d3d.LoadObject(10+i,"f15.x");
		Enemy[i].x=(float)(rand()%10);
		Enemy[i].z=(float)(rand()%10);
	}
}

void EnemyPlane()
{
	float x,z;
	int i;
	for(i=0;i<MAX_ENEMY;++i){

		EnemyWait[i] ++;
		if(EnemyWait[i]>30){
			float at=(float)atan2(Player.x-Enemy[i].x,Player.z-Enemy[i].z) -PI;
		//	if(at<0)at+=PI2;
			EnemyRad[i]=at;//ڕWpx += 0.01f;
 			EnemyWait[i] =0;
			if(at>PI)at -=PI2;
			if(at<-PI) at +=PI2;
			EnemyMuki[i]=0;
			float f1=EnemyRad[i] - Enemy[i].rx;// -PI;
			//Enemy[i].rx=at;//EnemyRad[i];
			if(f1>PI)f1 -=PI2;
			if(f1<-PI) f1 +=PI2;
			if(f1>0.2){
				EnemyMuki[i]=1;
			}
			if(f1<-0.2){
				EnemyMuki[i]=-1;
			}
		}
		if(EnemyMuki[i]>0){
			Enemy[i].rx -=0.05f;
		}else{
			Enemy[i].rx +=0.05f;
		}

		if(Enemy[i].rx>PI)
			Enemy[i].rx=Enemy[i].rx -PI2;
		if(Enemy[i].rx< -PI)
			Enemy[i].rx=Enemy[i].rx + PI2;
		Enemy[i].rz=Enemy[i].rx;
//		float sx=(float)sin(Enemy[i].rx)/100.0f;
//		float sz=(float)cos(Enemy[i].rz)/100.0f;
		Enemy[i].x +=(float)sin(Enemy[i].rx)/10.0f;
		Enemy[i].z +=(float)cos(Enemy[i].rz)/10.0f;
//	sprintf(d3d.DebugString,"(%4d %4d %4d)",int(EnemyRad[i]*100),int(sx*1000),int(sz*1000));
		x=Enemy[i].x;
		z=Enemy[i].z;
		d3d.SetObjectPos(10+i,x,0,z,
			0,Enemy[i].rx -(PI/2.0f),0);
	}

}
void PlayerMain()
{
	int i;
	const int num=298;
	for(i=299;i>0;--i){
		Camera[i].x=Camera[i-1].x;
		Camera[i].y=Camera[i-1].y;
		Camera[i].z=Camera[i-1].z;
		Camera[i].rx=Camera[i-1].rx;
		Camera[i].ry=Camera[i-1].ry;
		Camera[i].rz=Camera[i-1].rz;
	}
	float rad=Player.rz;
	if(GetAsyncKeyState(VK_LEFT)&0x8000){
		rad -=0.03f;
	}
	if(GetAsyncKeyState(VK_RIGHT)&0x8000){
		rad +=0.03f;
	}
	if(rad>PI2)rad=0.0f;
	if(rad<0) rad=PI2 - 0.01f;
	Player.rx=Player.rz=rad;
	if(GetAsyncKeyState(VK_UP)&0x8000){
		Speed++;
		if(Speed>110)Speed=110;
	}
	if(GetAsyncKeyState(VK_DOWN)&0x8000){
		Speed--;
		if(Speed<0)Speed=0;
	}
	if(GetAsyncKeyState('Q')&0x8000){
		Player.x=0.0f;
		Player.z=0.0f;
		Enemy[0].x=0.0f;
		Enemy[0].z=0.0f;
	}
	if(Speed){
		Player.x+=(float)sin(Player.rx)/(20.0f-(Speed/10));
		Player.z+=(float)cos(Player.rz)/(20.0f-(Speed/10));
	}
		if(Player.x<-300)Player.x=300;
		if(Player.y<-300)Player.y=300;
		if(Player.x>300)Player.x=-300;
		if(Player.y>300)Player.y=-300;
		Camera[0].x=Player.x;
		Camera[0].y=Player.y;
		Camera[0].z=Player.z;
//	Camera[0].x=Player.x+sin(Player.rx)/100.0f;
//	Camera[0].z=Player.z+cos(Player.rz)/100.0f;
		Camera[0].rx=Player.rx-PI/2;
		Camera[0].ry=Player.ry;
		Camera[0].rz=Player.rz;
	d3d.SetObjectPos(0,Player.x,Player.y,Player.z,
		0,Player.rx -PI/2,0);//+
/*	for(i=1;i<10;++i){
		d3d.SetObjectPos(3+i,Camera[i*30].x,Camera[i*30].y-2-i,Camera[i*30].z ,
			0,Camera[i*30].rx,0);//+
	}*/
//	sprintf(d3d.DebugString,"(%f %f )",Player.x,Player.z);
	//JʒuvZ
	float cx,cz;
	cx=Camera[10].x - (float)sin(Player.rx);
	cz=Camera[10].z - (float)cos(Player.rz);
	d3d.SetCameraPos(cx,0.2f+ViewMode*30,cz,
		Player.x,Player.y,Player.z);
}
void Loop()
{
	//
	PlayerMain();
	EnemyPlane();

	d3d.Render();
}
//-----------------------------------------------------------------------------
// Name: WinMain()
// Desc: The application's entry point
//-----------------------------------------------------------------------------
INT WINAPI WinMain( HINSTANCE hInst, HINSTANCE, LPSTR, INT )
{
    // Register the window class
    WNDCLASSEX wc = { sizeof(WNDCLASSEX), CS_CLASSDC, MsgProc, 0L, 0L, 
                      GetModuleHandle(NULL), NULL, NULL, NULL, NULL,
                      "D3D Tutorial", NULL };
    RegisterClassEx( &wc );
	HWND hWnd;

    // Create the application's window
    hWnd = CreateWindow( "D3D Tutorial", "D3D Flight Sim", 
                              WS_OVERLAPPEDWINDOW, 0, 0, 640, 480,
                              GetDesktopWindow(), NULL, wc.hInstance, NULL );

    // Initialize Direct3D
   if( SUCCEEDED( d3d.InitD3D( hWnd ) ) )
    { 
		d3d.SetCameraPos(0,0,-2.0);
        // Create the scene geometry
        //if( SUCCEEDED( d3d.InitGeometry("f15.x") ) )
        {
			d3d.InitLight();
			Init();
            // Show the window
            ShowWindow( hWnd, SW_SHOWDEFAULT );
            UpdateWindow( hWnd );

            // Enter the message loop
            MSG msg; 
            ZeroMemory( &msg, sizeof(msg) );
            while( msg.message!=WM_QUIT )
            {
                if( PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE ) )
                {
                    TranslateMessage( &msg );
                    DispatchMessage( &msg );
                }
                else{
					Loop();
				}
            }
        }
    }

    // Clean up everything and exit the app
    d3d.Cleanup();
    UnregisterClass( "D3D Tutorial", wc.hInstance );
    return 0;
}



